; vim: set ft=nasm noet ts=4:

bits 32

org 0x324B0000 ; :)

%include "cst.inc"
%include "sys.inc"

ehdr:
	db 0x7F,"ELF"

_start.0:
	; 4 unnecessary bytes
	mov al, SYS_close
	mov bl, STDERR_FILENO
	; 8 bytes of padding
	int 0x80

	xchg eax, ebx;mov al, SYS_fork	;STDERR_FILENO == SYS_fork
	int 0x80

	test eax, eax

	db 0x68 ; push ...
	;jmp short _start.1

	dw 2			;!e_type
	dw 3			;!e_machine
_start.1:
	;dd 0			; e_version
	jz  short  child.0
	jmp short parent.0
	;dd _start		;!e_entry
	dd _start.0		;!e_entry
	dd phdr - ehdr	;!e_phoff
child.0:
	;dd 0			; e_shoff
	mov al, SYS_execve
	push 0
	;dd 0			; e_flags
	;dw ehdr.end-ehdr; e_ehsize
	push arg2
	db 0x3D
	dw phdr.end-phdr;!e_phentsize
	dw 1			;!e_phnum
child.1:
	;dw 0			; e_shentsize
	;dw 0			; e_shnum
	push arg1
ehdr.endm1:
ehdr.end equ ehdr.endm1 + 1
	;dw 0			; e_shstrndx
	push arg0
	push args
	pop ebx
	mov ecx, esp
	int 0x80

phdr:
	dd 1			;!p_type
	dd 0			;!p_offset
	dd ehdr			;!p_vaddr
parent.0:
	;dd 0			; p_paddr
	push eax
	push eax ; nop
	push eax ; nop
	push eax ; nop
	;dd filesize		;~p_filesz	; needs to be equal to p_memsz, not too large,
	;;;;							; but can be larger than actual filesize
	jmp short parent.1
	dw 0
	;dd filesize		;~p_memsz	; ^
	jmp short parent.1+4
	dw 0
	;dd 5			;~p_flags	; bottom 3 bits only, 4 | 1, BUT NO 2
	;dd 0			; p_align
parent.1:
	mov ecx, ascii0 ; 0xB9 ... -> OK ^
	push 0
phdr.endm1:
phdr.end equ phdr.endm1 + 1
	push 0

;_start:
;	mov al, SYS_close
;	mov bl, STDERR_FILENO
;	int 0x80

;	xchg eax, ebx;mov al, SYS_fork	;STDERR_FILENO == SYS_fork
;	int 0x80
;	test eax, eax
;	jnz short parent

;child:
;	; bleh
;	mov al, SYS_execve
;	push 0
;;	push arg2
;	push arg1
;	push arg0
;	push args
;	pop ebx
;	mov ecx, esp
;	int 0x80

;parent:
;	mov ecx, ascii0

;	push eax
;	push 0
;	push 0

	push SYS_write ; for 2nd write(2) call
	push SYS_write
	pop eax
	mov bl, STDOUT_FILENO
	mov dx, ascii0.end-ascii0
	int 0x80

	;;xchg edx, ecx
	;;add dx, ascii-ascii0
	lea edx, [ecx+ascii-ascii0]

	push 0 ; 0 ns
	push 1 ; 1 sec
	push SYS_nanosleep
	pop eax
	mov ebx, esp
	pop ecx ; sec
	pop ecx ; ns
	int 0x80

	pop eax
	push STDOUT_FILENO
	pop ebx
	xchg ecx, edx
	mov dx, ascii.end-ascii
	int 0x80

	push SYS_waitpid
	pop eax ; waitpid
	pop edx ; 0
	pop ecx ; 0
	pop ebx ; *old* eax (child pid)
	int 0x80

	push SYS_exit
	pop eax
	int 0x80
	;int3

args:
arg0:
%ifndef USE_SPD_SAY
	db "/usr/bin/espeak",0 ; not /bin/espeak... ubuntu sucks
%else
	db "/usr/bin/spd-say",0 ; because some default ubuntu installs only have
							; libespeak and speechd... *sigh*
%endif
arg1:
%ifndef USE_SPD_SAY
	db "-vsv",0 ; yep
%else
	db "-wlsv",0 ; w -> wait
%endif
arg2:
	db "envidia...fuck jo",0
args.end:

ascii0:
	db 0x1b,'c' ; reset
	incbin "ascii0.txt"
.end:
ascii:
	db 0x1b,'c' ; reset
	incbin "ascii.txt"
.end:

END:

filesize equ END      - ehdr

